import { createPropertiesWeakMap } from '../utils';
export var coalescingManager = createCoalesceManager();
var ɵ0 = function (ctx) { return ({
    numCoalescingSubscribers: 0
}); };
var coalescingContextPropertiesMap = createPropertiesWeakMap(ɵ0);
function createCoalesceManager() {
    return {
        remove: removeWork,
        add: addWork,
        isCoalescing: isCoalescing
    };
    // Increments the number of subscriptions in a scope e.g. a class instance
    function removeWork(scope) {
        if (scope === void 0) { scope = {}; }
        var numCoalescingSubscribers = coalescingContextPropertiesMap.getProps(scope).numCoalescingSubscribers -
            1;
        coalescingContextPropertiesMap.setProps(scope, {
            numCoalescingSubscribers: numCoalescingSubscribers
        });
    }
    // Decrements the number of subscriptions in a scope e.g. a class instance
    function addWork(scope) {
        if (scope === void 0) { scope = {}; }
        var numCoalescingSubscribers = coalescingContextPropertiesMap.getProps(scope).numCoalescingSubscribers +
            1;
        coalescingContextPropertiesMap.setProps(scope, {
            numCoalescingSubscribers: numCoalescingSubscribers
        });
    }
    // Checks if anybody else is already coalescing atm
    function isCoalescing(scope) {
        if (scope === void 0) { scope = {}; }
        return (coalescingContextPropertiesMap.getProps(scope).numCoalescingSubscribers >
            0);
    }
}
export { ɵ0 };
//# sourceMappingURL=coalescing-manager.js.map